
library mid;

uses Windows, MMSystem;

var
  FFileName : PCHar;
  FHandle : HWND;
  FFrames : Longint;
  FFlags : Longint;
  FError : Longint;
  FDeviceID : Word;

procedure Close; stdcall;
var
  Gen : TMCI_Generic_Parms;
begin
{
  Zamknij - przestan odtwarzac dzwiek.
}
  FFlags := mci_Notify;
  Gen.dwCallback := FHandle;
  FError := mciSendCommand(FDeviceID, mci_Close, FFlags, Longint(@Gen));
end;

procedure Stop; stdcall;
var
  GenParm: TMCI_Generic_Parms;
begin
{
  Przestan odtwarzac dzwiek.
}
  FFlags := mci_Notify;
  GenParm.dwCallback := FHandle;
  FError := mciSendCommand(FDeviceID, mci_Stop, FFlags, Longint(@GenParm));
  Close;  // <-- wywolaj procedure Close zamykajaca na "Amen" odtwarzanie dzwieku
end;

function Length : LongInt; stdcall;
var
  Status : TMCI_Status_Parms;
begin
{
  Ta procedura jako rezultad zwraca dlugos odtwarzanego utworu.
}
  FFlags := mci_Wait or mci_Status_Item;
  Status.dwItem := mci_Status_Length;
  FError := mciSendCommand(FDeviceID, mci_Status, FFlags, Longint(@Status));
  Result := Status.dwReturn;
end;       

procedure Open(const AFileName : PCHar; _HWND : HWND); stdcall;
var
  OpenParm: TMCI_Open_Parms;
begin
{  Przypisz parametry zmiennym globalnym }
  FFileName := AFileName;
  FHandle := _HWND;
 {
   Otworz plik dzwiekowy i przygotuj go do odtwarzania.
 }
  OpenParm.dwCallback := 0;
  OpenParm.lpstrElementName := (FFileName);
  FFlags := mci_Open_Element;
  OpenParm.dwCallback := FHandle;
  FError := mciSendCommand(0, mci_Open, FFlags, LongInt(@OpenParm));

  FDeviceID := OpenParm.wDeviceID;
  FFrames := Length div 10;
end;


procedure Play; stdcall;
var
  PlayParms : TMCI_Play_Parms;
begin
{
  Rozpocznij odtwarzania utworu.
}
  FFlags := mci_Notify;
  PlayParms.dwCallback := FHandle;
  FError := mciSendCommand(FDeviceID, mci_Play, FFlags, Longint(@PlayParms));
end;

{ Eksportuj procedury }
exports
  Play name 'Play',
  Stop name 'Stop',
  Open name 'Open',
  Length name 'Length';

begin
end.
 